// FString Implementation File
#include "FString.h"
#include <iostream.h>

FString::FString(char *InputString)
{
	m_string = InputString;
}

FString::~FString()
{
	cout<< "The program was successfully destructed\n";
}

void FString::Display (void)
{
	int temp_length;
	char *temp_string;

	temp_length= Length(); // get the length of the string
	temp_string=m_string;

	for (int i=0; i<temp_length; i++)
	{
		cout << temp_string[i];
	}
}

void FString::Display (char *prefix, char*suffix, BOOL needCRLF)
{
	m_prefix=prefix;
	m_suffix=suffix;

	if (needCRLF==1)
	{
		cout << m_prefix << m_suffix << endl;
	}
	else if (needCRLF==0)
	{
		cout << m_prefix << m_suffix;
	}
	else
	{
		cout << "Invalid Argument. Enter either True or False" << endl;
	}

}

int FString::Length (void)
{
	int counter=0;
	char *startPtr;
	startPtr = m_string;

	while ( *startPtr != '\0' && counter < MAX_STRING )
	{
		counter += 1;
		startPtr +=1;
	}
	m_string_length=counter;

	if (counter >= MAX_STRING )
	{
		m_string_length = MAX_STRING;
	}

	return m_string_length;
}

char FString::Get_At (int index)
{
	if (index > 0 && index <= Length())
	{
		return m_string[index-1];
	}
	else
	{
		return '*';		
	}
}

BOOL FString::Put_At (char c, int index)
{
	if (index > 0 && index <= Length())
	{
		m_string[index-1] = c;
		return TRUE;
	}
	else
	{	
		return FALSE;
	}
}

BOOL FString::Is_Empty (void)
{
	if (Length()) return FALSE;
	else return TRUE;
}
